<template>
  <div>
    <v-row>
      <v-col class="ml-5">
        <h1>TODO app v0.0.1</h1>
      </v-col>
    </v-row>
    <v-row class="mt-3">
      <v-col class="d-flex ml-5">
        <v-form>
          <v-text-field
            v-model="searchFilter"
            @input="onSearchFilterChange"
            placeholder="Search..."
          ></v-text-field>
        </v-form>
      </v-col>
      <v-col>
        <ul>
          <li>Drag TODO items around or into different columns</li>
          <li>Click on TODO item to open a dialog where you can edit full information</li>
          <li>Use search to filter out </li>
        </ul>
      </v-col>
    </v-row>
      <v-row class="column-list overflow-x-auto flex-nowrap">
          <template v-for="todoList in allLists"  >
            <v-col :key="todoList.id">
              <TodoList :todoList="todoList" :onEdit="openTodoDialog" />
              <!-- :todos="todos" -->
          </v-col>
          </template>
          <v-col>
          <NewListForm 
            v-show="showNewListForm" 
            :onCreate="createNewList"
            :onCancel="()=>{ showNewListForm = false }"
            >
          </NewListForm>
          <v-btn 
            v-show="!showNewListForm" 
            @click="toggleNewList">+ Add a list
          </v-btn>
        </v-col>
      </v-row>

    <v-dialog v-model="showEditDialog" >
      <v-card>
        <EditTodoFull v-if="showEditDialog"
          :todo="editTodo" 
          :onChange="onUpdateTodo" 
          />
      </v-card>
    </v-dialog>
   
  </div>
</template>

<script>
import NewListForm from '@/components/NewListForm.vue';
import TodoList from '@/components/TodoList.vue';
import EditTodoFull from '@/components/EditTodoFull.vue';
import { mapActions, mapGetters } from 'vuex';

export default {
    components:{
      NewListForm,
      TodoList,
      EditTodoFull,
    },
    data:()=>({
      showNewListForm: false,

      editTodo: null,
      showEditDialog: false,
      // searchFilter: '',
    }),
    mounted(){

    },
    computed:{
      ...mapGetters([
          'allLists',
          'todos',
          'sortedTodos',
          'search',
      ]),
      searchFilter:{
        get(){
          return this.search;
        },
        set(value){
          console.log('update search', value);
          this.updateSearch(value);
        }
      }
    },
    watch:{
      showEditDialog(value){
        if(!value){
          this.$nextTick(()=>{
            this.editTodo = null;
          })
        }
      }
    },
    methods:{
      ...mapActions([
        'addList',
        'updateTodo',
        'updateSearch',
      ]),
      createNewList(newList){
        this.addList(newList);
        // this.toggleNewList();
      },
      toggleNewList(){
        this.showNewListForm = !this.showNewListForm;
      },
      onUpdateTodo(todoId, updates){
          this.updateTodo({ todoId, updates });
      },
      openTodoDialog(todo){
          console.log('OPEN DIALOG', todo)
          this.editTodo = todo;
          this.showEditDialog = true;
      },
      onSearchFilterChange(){
        console.log('search', this.searchFilter)
      },
    }
}
</script>

<style lang="scss" scoped>
  .column-list{
    padding: 0;
    margin: 0; 


    .col{
      min-width: 250px;
      max-width: 250px;
    }
  }
</style>